unit u_Usuarios;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DBCtrls, Mask, Buttons, ExtCtrls, DB, DBTables;

type
  TFUsuario = class(TForm)
    GroupBox1: TGroupBox;
    Label2: TLabel;
    DBEdit2: TDBEdit;
    Label3: TLabel;
    DBEdit3: TDBEdit;
    Label4: TLabel;
    DBEdit4: TDBEdit;
    Label5: TLabel;
    DBEdit5: TDBEdit;
    Label6: TLabel;
    DBEdit6: TDBEdit;
    Label7: TLabel;
    DBEdit7: TDBEdit;
    Label8: TLabel;
    DBEdit8: TDBEdit;
    Label9: TLabel;
    DBEdit9: TDBEdit;
    GroupBox2: TGroupBox;
    DBCheckBox2: TDBCheckBox;
    DBCheckBox1: TDBCheckBox;
    Panel1: TPanel;
    novo: TBitBtn;
    gravar: TBitBtn;
    editar: TBitBtn;
    deletar: TBitBtn;
    cancelar: TBitBtn;
    navegador: TDBNavigator;
    BitBtn2: TBitBtn;
    Label10: TLabel;
    DBEdit10: TDBEdit;
    Label11: TLabel;
    DBEdit11: TDBEdit;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    DBCheckBox3: TDBCheckBox;
    DBCheckBox4: TDBCheckBox;
    DBCheckBox5: TDBCheckBox;
    Label15: TLabel;
    DBCheckBox6: TDBCheckBox;
    DBEdit1: TDBEdit;
    procedure novoClick(Sender: TObject);
    procedure editarClick(Sender: TObject);
    procedure deletarClick(Sender: TObject);
    procedure cancelarClick(Sender: TObject);
    procedure gravarClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    procedure tabelavazia;
    procedure botoes;
    function duplicado(x:integer):boolean;
  public
    { Public declarations }
  end;

var
  FUsuario : TForm;
  velho : integer;
implementation

uses u_DM;

{$R *.dfm}

function TFUsuario.duplicado(x:integer):boolean;
var
t: TTable;
begin
t := TTable.create(self);
with t do
begin
DatabaseName := 'Locadora'; {Nome do Alias}
TableName := 'Usuarios.db';
IndexFieldNames:='UsuCodigo';
open;
if DataModule1.TUsuario.State =DsEdit then
begin
if velho<>strtoint(dbedit1.text) then
begin
  if findkey([x]) then result:=true
  else result:=false;
end
else result := false;
end;

if DataModule1.TUsuario.State =DsInsert then
begin
  if findkey([x]) then result:=true
  else result:=false;
end;
close;
free;
end;
end;


procedure TFUsuario.tabelavazia;
begin
if datamodule1.TUsuario.recordcount<1 then
begin
  novo.enabled:=true;
  editar.enabled:=false;
  deletar.enabled:=false;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
end
else begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.enabled:=true;
end;
end;

procedure TFUsuario.botoes;
begin
novo.enabled:=false;
editar.enabled:=false;
deletar.Enabled:=false;
cancelar.enabled:=true;
gravar.enabled:=true;
navegador.enabled:=editar.enabled;
end;


procedure TFUsuario.novoClick(Sender: TObject);
var x:integer;
begin
DataModule1.TUsuario.IndexFieldNames := 'UsuCodigo';
DataModule1.TUsuario.IndexName := '';
DataModule1.TUsuario.Last;
x := (DataModule1.TUsuario.FieldByName('UsuCodigo').AsInteger + 1);
datamodule1.DSUsuario.AutoEdit:=true;
datamodule1.TUsuario.Insert;
DataModule1.TUsuario.FieldByName('UsuCodigo').AsInteger := x;
datamodule1.TUsuario.FieldByName('AutMovBD').asBoolean := False;
datamodule1.TUsuario.FieldByName('AutRelSC').asBoolean := False;
datamodule1.TUsuario.FieldByName('AutUsu').asBoolean := False;
datamodule1.TUsuario.FieldByName('AutCli').asBoolean := False;
datamodule1.TUsuario.FieldByName('AutFil').asBoolean := False;
datamodule1.TUsuario.FieldByName('AutConC').asBoolean := False;
botoes;
end;

procedure TFUsuario.editarClick(Sender: TObject);
begin
velho:=strtoint(dbedit1.text);
datamodule1.TUsuario.Edit;
datamodule1.DSUsuario.AutoEdit:=true;
//controla botoes enabled
botoes;
end;

procedure TFUsuario.deletarClick(Sender: TObject);
begin
if MessageDlg('EXCLUIR O REGISTRO?', mtConfirmation, [mbYes,mbNo], 0)=mrYes then
begin
  datamodule1.TUsuario.delete;
end;
tabelavazia;

end;

procedure TFUsuario.cancelarClick(Sender: TObject);
begin
datamodule1.TUsuario.Cancel;
//controla botoes enabled
novo.enabled:=true;
editar.enabled:=true;
deletar.enabled:=true;
cancelar.Enabled:=false;
gravar.Enabled:=false;
navegador.enabled:=true;
tabelavazia;
end;

procedure TFUsuario.gravarClick(Sender: TObject);
begin
if (not duplicado(strtoint(dbedit1.text))) then
begin
  novo.enabled:=true;
  editar.enabled:=true;
  deletar.enabled:=true;
  cancelar.Enabled:=false;
  gravar.Enabled:=false;
  navegador.Enabled:=true;
  DataModule1.TUsuario.post;
  datamodule1.TUsuario.IndexFieldNames := '';
  datamodule1.DSUsuario.Autoedit := False;
end
else begin
  showmessage('Registro duplicado');
end;
end;

procedure TFUsuario.BitBtn2Click(Sender: TObject);
begin
close;
end;

procedure TFUsuFUsuariomClose(Sender: TObject; var Action: TCloseAction);
begin
if (datamodule1.TUsuario.State = dsinsert) or (datamodule1.TUsuario.State = dsEdit)
then datamodule1.TUsuario.Cancel;

end;

procedure TFUsuario.FormShow(Sender: TObject);
begin
datamodule1.TUsuario.First;
datamodule1.DSUsuario.AutoEdit:=false;
//controla botoes enabled
tabelavazia;
end;

procedure TFUsuario.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if (datamodule1.TUsuario.State = dsinsert) or (datamodule1.TUsuario.State = dsEdit)
then datamodule1.TUsuario.Cancel;
end;

end.
