unit u_BCDebito;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Grids, DBGrids, SuperEdit;

type
  TFDebito = class(TForm)
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    Label2: TLabel;
    codigo: TSuperEdit;
    nome: TSuperEdit;
    DBGrid1: TDBGrid;
    g: TGroupBox;
    a2: TLabel;
    Bevel3: TBevel;
    Bevel2: TBevel;
    Bevel1: TBevel;
    Bevel6: TBevel;
    Bevel9: TBevel;
    Bevel10: TBevel;
    a7: TLabel;
    BitBtn2: TBitBtn;
    credito: TEdit;
    debito: TEdit;
    Button1: TButton;
    Button2: TButton;
    procedure FormShow(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure codigoChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure debitoKeyPress(Sender: TObject; var Key: Char);
    procedure Button2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FDebito: TFDebito;

implementation

uses u_DM, u_CDClientes;

{$R *.dfm}

procedure TFDebito.FormShow(Sender: TObject);
begin
Debito.Text := '0,00';
Credito.Text := '0,00';
codigo.text := '';
nome.text := '';
DataModule1.TMovimento.Filtered := false;
DataModule1.TMovimento.Filter := 'MovCliente > 9999999';
DataModule1.TMovimento.Filtered := true;
end;

procedure TFDebito.BitBtn2Click(Sender: TObject);
begin
Close;
end;

procedure TFDebito.codigoChange(Sender: TObject);
begin

if Trim(codigo.text)<>'' then
begin
  DataModule1.TClientes.IndexName := 'Cdigo';
  if DataModule1.TClientes.Findkey([codigo.text]) then
  begin
     nome.text := DataModule1.TClientes.FieldByName('CliNome').asString;
     DataModule1.TMovimento.Filtered := false;
     DataModule1.TMovimento.Filter := 'MovCliente = ' + codigo.text ;
     DataModule1.TMovimento.Filtered := true;
  end
  else begin
    nome.text := '';
    DataModule1.TMovimento.Filtered := false;
    DataModule1.TMovimento.Filter := 'MovCliente > 9999999';
    DataModule1.TMovimento.Filtered := true;
  end;
end;

end;

procedure TFDebito.Button1Click(Sender: TObject);
begin
if DataModule1.TMovimento.RecordCount > 0 then
begin
   if DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat >= StrToFloat(debito.text) then
   begin
     DataModule1.TMovimento.Edit;
     DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat :=
       DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat - StrtoFloat(debito.Text);
     DataModule1.TMovimento.Post;
   end;
end;
end;

procedure TFDebito.debitoKeyPress(Sender: TObject; var Key: Char);
begin
if (key in ['a'..'z']) and (key in ['A'..'Z']) then key := #0;
end;

procedure TFDebito.Button2Click(Sender: TObject);
begin

if DataModule1.TMovimento.RecordCount > 0 then
begin
 DataModule1.TMovimento.Edit;
 DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat :=
    DataModule1.TMovimento.FieldByName('MovValorDebito').AsFloat + StrtoFloat(credito.Text);
 DataModule1.TMovimento.Post;
end;

end;

procedure TFDebito.SpeedButton1Click(Sender: TObject);
begin
FCC.Formulario := 'FDebito';
FCC.ShowModal;
end;

end.
