unit u_DM;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, ComCtrls, StdCtrls, DBCtrls, DB, Mask, DBTables, DBIProcs;

type
  TDataModule1 = class(TDataModule)
    TClientes: TTable;
    DSClientes: TDataSource;
    TClientesCliCodigo: TIntegerField;
    TClientesCliNome: TStringField;
    TClientesCliRG: TStringField;
    TClientesCliCPF: TStringField;
    TClientesCliEndereco: TStringField;
    TClientesCliCidade: TStringField;
    TClientesCliCEP: TStringField;
    TClientesCliTelefone: TStringField;
    TClientesCliDataAdesao: TDateField;
    TClientesCliEmail: TStringField;
    TClientesBloqueado: TBooleanField;
    TClientesCliFoto: TGraphicField;
    TFilmes: TTable;
    DSFilmes: TDataSource;
    TFilmesFilCodigo: TIntegerField;
    TFilmesFilTitulo: TStringField;
    TFilmesFilOriginal: TStringField;
    TFilmesFilAtores: TStringField;
    TFilmesFilDiretor: TStringField;
    TFilmesFilPais: TStringField;
    TFilmesFilAno: TIntegerField;
    TFilmesFilDuracao: TStringField;
    TFilmesFilAquisicao: TDateField;
    TFilmesFilGenero: TIntegerField;
    TFilmesFilDistribuidor: TIntegerField;
    TFilmesFilCategoria: TIntegerField;
    TFilmesFilValorAquisicao: TCurrencyField;
    TUsuario: TTable;
    DSUsuario: TDataSource;
    TUsuarioUsuCodigo: TIntegerField;
    TUsuarioUsuNome: TStringField;
    TUsuarioUsuCPF: TStringField;
    TUsuarioUsuRG: TStringField;
    TUsuarioUsuAdmissao: TDateField;
    TUsuarioUsuEndereco: TStringField;
    TUsuarioUsuCidade: TStringField;
    TUsuarioUsuCEP: TStringField;
    TUsuarioUsuTelefone: TStringField;
    TClientesCliDataNascimento: TDateField;
    TAutorizados: TTable;
    DSAutorizados: TDataSource;
    TAutorizadosRegistro: TAutoIncField;
    TAutorizadosAutCliCodigo: TIntegerField;
    TAutorizadosAutNome: TStringField;
    TAutorizadosAutRG: TStringField;
    TAutorizadosAutCPF: TStringField;
    TFilmesFilValorCategoria: TCurrencyField;
    TGenero: TTable;
    DSGenero: TDataSource;
    TGeneroGenCodigo: TIntegerField;
    TGeneroGenDescricao: TStringField;
    TGeneroCenIdade: TIntegerField;
    TGeneroGenCensura: TBooleanField;
    TDistribuidor: TTable;
    DSDistribuidor: TDataSource;
    TDistribuidorDisCodigo: TIntegerField;
    TDistribuidorDisDescricao: TStringField;
    TDistribuidorDisEndereco: TStringField;
    TDistribuidorDisTelefone: TStringField;
    TDistribuidorDisEmail: TStringField;
    TCategoria: TTable;
    DSCategoria: TDataSource;
    TCategoriaCatCodigo: TIntegerField;
    TCategoriaCatValor: TCurrencyField;
    TCategoriaCatDescricao: TStringField;
    TFilmesCatDescr: TStringField;
    TFilmesGenDesci: TStringField;
    TMovimento: TTable;
    DSMovimento: TDataSource;
    TMovimentoRegistro: TAutoIncField;
    TMovimentoMovDataLocacao: TDateField;
    TMovimentoMovFormaPag: TStringField;
    TMovimentoMovTotal: TCurrencyField;
    TMovimentoMovValorDebito: TCurrencyField;
    TMovimentoMovDebito: TBooleanField;
    TMovimentoMovCliente: TIntegerField;
    TMovimentoClienteNome: TStringField;
    TAutorizadosAutDataNascimento: TDateField;
    TMovimentoMovEAut: TBooleanField;
    TMovimentoMovAutNome: TStringField;
    TLancamento: TTable;
    DSLancamento: TDataSource;
    TLancamentoRegistro: TAutoIncField;
    TLancamentoLMovRegistro: TIntegerField;
    TLancamentoLFilme: TIntegerField;
    TLancamentoTitulo: TStringField;
    TLancamentoValoCategoria: TFloatField;
    TMovimentoHoralocacao: TTimeField;
    TMovimentoMovPag: TStringField;
    TLancamentoLDataDevolucao: TDateField;
    TLancamentoLHoraDevolucao: TTimeField;
    TMovimentoMovDataDevolucao: TDateField;
    TMovimentoDataDR: TDateField;
    TLancamentoLDevolvido: TStringField;
    TClientesCliSaldo: TCurrencyField;
    TFilmesFilAlugado: TStringField;
    TFilmesFilMidia: TStringField;
    TFilmesFilMR: TIntegerField;
    TLancamentoLCliente: TIntegerField;
    TLancamentoLEAut: TBooleanField;
    TLancamentoLAutNome: TStringField;
    TLancamentoLDataLocacao: TDateField;
    TLancamentoLHoraLocacao: TTimeField;
    TLancamentoLFormaPag: TStringField;
    TLancamentoLPag: TStringField;
    TLancamentoCliente: TStringField;
    TLancamentoLDataDR: TDateField;
    TLancamentoCliNome: TStringField;
    TCaixa: TTable;
    DSCaixa: TDataSource;
    TCaixaData: TDateField;
    TCaixaSaldoInicial: TCurrencyField;
    TCaixaTroco: TCurrencyField;
    TCaixaEntrada: TCurrencyField;
    TMovimentoCliNome: TStringField;
    TCaixaSaldoFinal: TCurrencyField;
    TFilmesFilLegenda: TStringField;
    TUsuarioNick: TStringField;
    TUsuarioSenha: TStringField;
    TUsuarioAutMovBD: TBooleanField;
    TUsuarioAutRelSC: TBooleanField;
    TUsuarioAutUsu: TBooleanField;
    TUsuarioAutCli: TBooleanField;
    TUsuarioAutFil: TBooleanField;
    TUsuarioAutConC: TBooleanField;
    TClientesCliComplemento: TStringField;
    TClientesCliNumero: TStringField;
    TClientesCliBairro: TStringField;
    TLancamentoLUsuario: TStringField;
    TFilmesDistribuidor: TStringField;
    TLancamentoLPreco: TCurrencyField;
    TAutorizadosAutFoto: TGraphicField;
    TLancamentoCupom: TStringField;
    TAutorizadosAutParentesco: TStringField;
    TAutorizadosCliNome: TStringField;
    procedure TClientesAfterDelete(DataSet: TDataSet);
    procedure TClientesAfterPost(DataSet: TDataSet);
    procedure TFilmesAfterDelete(DataSet: TDataSet);
    procedure TFilmesAfterPost(DataSet: TDataSet);
    procedure TUsuarioAfterDelete(DataSet: TDataSet);
    procedure TUsuarioAfterPost(DataSet: TDataSet);
    procedure TAutorizadosAfterDelete(DataSet: TDataSet);
    procedure TAutorizadosAfterPost(DataSet: TDataSet);
    procedure TGeneroAfterDelete(DataSet: TDataSet);
    procedure TGeneroAfterPost(DataSet: TDataSet);
    procedure TDistribuidorAfterDelete(DataSet: TDataSet);
    procedure TDistribuidorAfterPost(DataSet: TDataSet);
    procedure TCategoriaAfterDelete(DataSet: TDataSet);
    procedure TCategoriaAfterPost(DataSet: TDataSet);
    procedure TMovimentoAfterDelete(DataSet: TDataSet);
    procedure TMovimentoAfterPost(DataSet: TDataSet);
    procedure TLancamentoAfterDelete(DataSet: TDataSet);
    procedure TLancamentoAfterPost(DataSet: TDataSet);
    procedure TCaixaAfterDelete(DataSet: TDataSet);
    procedure TCaixaAfterPost(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DataModule1: TDataModule1;

implementation

{$R *.dfm}

procedure TDataModule1.TClientesAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TClientes.handle);
end;

procedure TDataModule1.TClientesAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TClientes.handle);
end;

procedure TDataModule1.TFilmesAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TFilmes.handle);
end;

procedure TDataModule1.TFilmesAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TFilmes.handle);
end;

procedure TDataModule1.TUsuarioAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TUsuario.handle);
end;

procedure TDataModule1.TUsuarioAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TUsuario.handle);
end;

procedure TDataModule1.TAutorizadosAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TAutorizados.handle);
end;

procedure TDataModule1.TAutorizadosAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TAutorizados.handle);
end;

procedure TDataModule1.TGeneroAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TGenero.handle);
end;

procedure TDataModule1.TGeneroAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TGenero.handle);
end;

procedure TDataModule1.TDistribuidorAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TDistribuidor.handle);
end;

procedure TDataModule1.TDistribuidorAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TDistribuidor.handle);
end;

procedure TDataModule1.TCategoriaAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TCategoria.handle);
end;

procedure TDataModule1.TCategoriaAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TCategoria.handle);
end;

procedure TDataModule1.TMovimentoAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TMovimento.handle);
end;

procedure TDataModule1.TMovimentoAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TMovimento.handle);
end;

procedure TDataModule1.TLancamentoAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TLancamento.handle);
end;

procedure TDataModule1.TLancamentoAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TLancamento.handle);
end;

procedure TDataModule1.TCaixaAfterDelete(DataSet: TDataSet);
begin
DBISaveChanges(TCaixa.handle);
end;

procedure TDataModule1.TCaixaAfterPost(DataSet: TDataSet);
begin
DBISaveChanges(TCaixa.handle);
end;

end.
