unit u_MDevolucao;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SuperEdit, ComCtrls,DateUtils, Buttons;

type
  TFDevolucao = class(TForm)
    GroupBox1: TGroupBox;
    Codigo: TSuperEdit;
    Label1: TLabel;
    Label16: TLabel;
    g: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    tipo: TLabel;
    Label6: TLabel;
    data: TLabel;
    codcliente: TLabel;
    nome: TLabel;
    total: TLabel;
    Label14: TLabel;
    valor: TLabel;
    Label17: TLabel;
    titulo: TLabel;
    a3: TEdit;
    a5: TEdit;
    a6: TEdit;
    a8: TEdit;
    a7: TLabel;
    Label8: TLabel;
    a4: TLabel;
    a2: TLabel;
    a1: TComboBox;
    lac: TLabel;
    Pag: TLabel;
    DataD: TDateTimePicker;
    f5: TSpeedButton;
    multa: TEdit;
    cobrar: TButton;
    Label4: TLabel;
    Button2: TButton;
    saldo: TEdit;
    lsaldo: TLabel;
    L1: TLabel;
    Valores: TBitBtn;
    procedure CodigoKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure CodigoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure a3KeyPress(Sender: TObject; var Key: Char);
    procedure cobrarClick(Sender: TObject);
    procedure f5Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ValoresClick(Sender: TObject);
    procedure DataDChange(Sender: TObject);
  private
    { Private declarations }
    procedure inicia;
    procedure TiraSaldo;
    procedure encerra;
    function valormulta:real;
  public
    { Public declarations }
  end;

var
  FDevolucao: TFDevolucao;
  SaldoI : String;
  TotalI,DebitoI:real;

implementation

uses u_DM, u_MLocacao, u_PreMovimento;

{$R *.dfm}

function TFDevolucao.valormulta : real;
var
  x : integer;
  data : TDateTime;
begin
  x := 0;
  result := 0;
  if DataD.Date > DataModule1.TLancamento.FieldByName('LDataDevolucao').AsDateTime then
  begin
    data := DataModule1.TLancamento.FieldByName('LDataDevolucao').AsDateTime;
    data := IncDay(Data,1);
    while data <= DataD.Date do
    begin
     data := IncDay(Data,1);
     x:= x + 1;
    end;
    result := x * DataModule1.TLancamento.FieldByName('ValoCategoria').AsFloat;
  end;
end;

procedure TFDevolucao.encerra;
var
tot,credito : real;
begin
if (g.Height=200) and (not (trim(a3.Text)='')) then begin
    tot := StrToFloat(a6.Text);
    credito := StrToFloat(a3.Text);
    if (credito > 0) and (credito >=tot)then begin
      a5.Text := FMovimento.FloatStr(FloatToStr(credito-tot));
      a8.Text := '0,00';
    end;
    if (credito >= 0) and (credito <tot) then a8.Text := FMovimento.FloatStr(FloatToStr(StrToFloat(a8.text) + (tot-credito)));
  end;

  if MessageDlg('DESEJA PROSSEGUIR ?' + #13 , mtConfirmation, [mbYes,mbNo], 0)=mrYes then
  begin
     if StrtoFloat(a6.text) > 0 then
     begin
        DataModule1.TCaixa.FindKey([Date]);
        DataModule1.TCaixa.Edit;
        DataModule1.TCaixa.FieldByName('Troco').asFloat := DataModule1.TCaixa.FieldByName('Troco').asFloat +
          StrToFloat(a5.Text);
        DataModule1.TCaixa.FieldByName('Entrada').asFloat := DataModule1.TCaixa.FieldByName('Entrada').asFloat +
          StrToFloat(a3.Text);
        DataModule1.TCaixa.FieldByName('SaldoFinal').asFloat := DataModule1.TCaixa.FieldByName('SaldoInicial').asFloat +
          (DataModule1.TCaixa.FieldByName('Entrada').asFloat -
            DataModule1.TCaixa.FieldByName('Troco').asFloat);

        DataModule1.TCaixa.Post;
      end;

     DataModule1.TMovimento.IndexFieldNames := 'Registro';
     DataModule1.TMovimento.FindKey([DataModule1.TFilmes.FieldByName('FilMR').asInteger]);
     DataModule1.TMovimento.Edit;
     with DataModule1.TMovimento do
     begin
        if StrToFloat(a8.Text) > 0 then
           FieldByName('MovDebito').asBoolean := True
        else  if StrToFloat(a8.Text) <= 0 then FieldByName('MovDebito').asBoolean := False;
        FieldByName('MovValorDebito').asFloat := StrToFloat(a8.text);
        FieldByName('DataDR').asDateTime := DataD.Date;
     end;
     DataModule1.TMovimento.Post;

     DataModule1.TLancamento.IndexName := 'Movimento';
     DataModule1.TLancamento.Filter:= 'LMovRegistro = ' +
     IntToStr(DataModule1.TFilmes.FieldByName('FilMR').asInteger);
     DataModule1.TLancamento.Filtered := True;
     DataModule1.TLancamento.IndexName := 'LFilme';
     DataModule1.TLancamento.FindKey([StrToInt(codigo.text)]);
     DataModule1.TLancamento.edit;
     DataModule1.TLancamento.FieldByName('LDevolvido').asString := 'Sim';
     DataModule1.TLancamento.FieldByName('LDataDR').value := DataD.Date;
     DataModule1.TLancamento.FieldByName('LHoraDevolucao').value := time;
     DataModule1.TLancamento.Post;
     DataModule1.TLancamento.Filtered := false;

     DataModule1.TFilmes.IndexFieldNames := 'FilCodigo';
     DataModule1.TFilmes.FindKey([StrToInt(codigo.text)]);
     DataModule1.TFilmes.edit;
     DataModule1.TFilmes.FieldByName('FilAlugado').asString := 'No';
     DataModule1.TFilmes.FieldByName('FilMR').Value := null;
     DataModule1.TFilmes.Post;


     DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
     DataModule1.TClientes.FindKey([StrToInt(codcliente.caption)]);
     DataModule1.TClientes.Edit;
     DataModule1.TClientes.FieldByName('CliSaldo').asFloat := StrtoFLoat(Saldo.Text);
     DataModule1.TClientes.Post;

     inicia;
     ShowMessage('Devoluo com SUCESSO !');
  end
  else ShowMessage('Voc tem que lanar os valores !');
end;

procedure TFDevolucao.TiraSaldo;
var tot,credito : real;
begin
  if StrToFloat(SaldoI) > StrToFloat(a6.Text) then
  begin
    x := (StrToFLoat(Saldo.text) - StrtoFloat(a6.text));
    a3.Text := FMovimento.FloatStr(FloatToStr(StrToFLoat(Saldo.text)-x));
    Saldo.Text := FMovimento.FloatStr(FloatToStr(x));
    LSaldo.Font.Color := clRed;
    tot := StrToFloat(a6.Text);
    credito := StrToFloat(a3.Text);
    a5.Text := FMovimento.FloatStr(FloatToStr(credito-tot));
    a8.Text := FMovimento.FloatStr(FloatToStr(tot-credito));
  end;

  if StrToFloat(SaldoI) = StrToFloat(a6.Text) then
  begin
   a3.Text := Saldo.Text;
   Saldo.Text := '0,00';
   tot := StrToFloat(a6.Text);
   credito := StrToFloat(a3.Text);
   a5.Text := FMovimento.FloatStr(FloatToStr(credito-tot));
   a8.Text := FMovimento.FloatStr(FloatToStr(tot-credito));
  end;

  if (StrToFloat(SaldoI) < StrToFloat(a6.Text)) and (StrToFloat(SaldoI)>0)then
  begin
  a3.Text := FMovimento.FloatStr(FloatToStr(StrToFloat(a6.Text) - StrToFloat(Saldo.Text)));
  Saldo.Text := '0,00';
  end;
end;

procedure TFDevolucao.Inicia;
begin
codigo.text := '';
DataModule1.TLancamento.Filtered := False;
DataModule1.TLancamento.IndexName := 'Devolvido';
DataModule1.TLancamento.Filter := 'LDevolvido = ' + '''' + 'No' + '''';
DataModule1.TLancamento.Filtered := True;
valor.Caption := '-';
Titulo.Caption := '-';
Data.Caption := '-';
CodCliente.caption := '-';
Nome.caption := '-';
total.caption := '-';
pag.caption := '-';
g.Height := 115;
multa.text := '0,00';
a5.text := '0,00';
a3.text := '0,00';
valores.Visible := False;
a1.Visible := false;
a2.Visible := false;
a3.Visible := false;
a4.Visible := false;
a5.Visible := false;
a6.Visible := false;
a7.Visible := false;
a8.Visible := false;
l1.Visible := False;
multa.Visible := false;
cobrar.Visible := false;
saldo.Visible := false;
lsaldo.Visible := false;
saldo.text := '0,00';
end;

procedure TFDevolucao.CodigoKeyPress(Sender: TObject; var Key: Char);

function debtotal(cliente:integer):real;
begin
DataModule1.TMovimento.Filtered := False;
DataModule1.TMovimento.First;
result := 0;
while not DataModule1.TMovimento.eof do
begin
 if (DataModule1.TMovimento.FieldByName('MovValorDebito').asFloat > 0) and
   (DataModule1.TMovimento.FieldByName('MovCliente').asInteger = cliente) then
   result := result + DataModule1.TMovimento.FieldByName('MovValorDebito').asFloat;
 DataModule1.TMovimento.Next;
end;

end;
begin
DataModule1.TLancamento.IndexName := 'LFilme';
if (key = #13) and (not (trim(codigo.text)='')) then
begin
   DAtamodule1.TFilmes.IndexFieldNames := 'FilCodigo';
   if DAtamodule1.TFilmes.FindKey([StrToInt(codigo.text)]) then
   begin
     if DAtamodule1.TFilmes.FieldByName('FilAlugado').asString = 'Sim' then
     begin
     titulo.caption := DAtamodule1.TFilmes.FieldByName('FilTitulo').asString;
     valor.caption := FMovimento.FloatStr((FloattoStr(DAtamodule1.TFilmes.FieldByName('FilValorCategoria').asFloat)));
     f5.Enabled := true;
     DataModule1.TMovimento.IndexFieldNames := 'Registro';

     { Colocar na hora de salvar
      DataModule1.TLancamento.Filtered := False;
      DataModule1.TLancamento.IndexName := 'Movimento';
      DataModule1.TLancamento.Filter := 'LMovRegistro = ' +
        IntToStr(DAtamodule1.TFilmes.FieldByName('FilMR').asInteger);
      DataModule1.TLancamento.Filtered := True;
      DataModule1.TLancamento.IndexName := 'LFilme';
      DataModule1.TLancamento.FindKey([StrToInt(codigo.text)]);}

       DataModule1.TLancamento.Filtered := False;
       DataModule1.TLancamento.IndexName := 'Movimento';
       DataModule1.TLancamento.Filter := 'LMovRegistro = ' +
         IntToStr(DAtamodule1.TFilmes.FieldByName('FilMR').asInteger);
       DataModule1.TLancamento.Filtered := True;
       DataModule1.TLancamento.IndexName := 'LFilme';
       DataModule1.TLancamento.FindKey([StrToInt(codigo.text)]);

       //alterando para nova tabela
       DataModule1.TMovimento.IndexFieldNames := 'Registro';
       DataModule1.TMovimento.FindKey([DataModule1.TLancamento.FieldByName('LMovRegistro').asInteger]);

       TotalI := StrtoFloat(valor.caption);
       DebitoI := DataModule1.TMovimento.FieldByName('MovValorDebito').asFloat;
       DataModule1.TClientes.IndexFieldNames := 'CliCodigo';
       DataModule1.TClientes.FindKey([DataModule1.TMovimento.FieldByName('MovCliente').asInteger]);
       Saldo.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TClientes.FieldByName('CliSaldo').asFloat));
       SaldoI := Saldo.Text;

       with DataModule1.TLancamento do
       begin
          Shortdateformat:= 'DDDD dd" de "mmmm" de "yyyy';
          Data.Caption :=DateToStr(FieldByName('LDataLocacao').asDateTime);
          Shortdateformat:= 'dd/mm/yyyy';
          CodCliente.Caption := IntToStr(FieldByName('LCliente').asInteger);
          Total.Caption := FMovimento.FloatStr(FloatToStr(debtotal(StrToInt(codcliente.caption))));
          if FieldByName('LEAut').asBoolean then
          begin
            Nome.Caption := FieldByName('LAutNome').asString;
            tipo.caption := 'Autorizado :'
          end
          else begin
             Nome.Caption := DataModule1.TLancamentoCliente.asString;
             tipo.caption := 'Cliente :';
          end;
          pag.Caption := FieldByName('LPag').AsString;
          a6.text := valor.caption;
          a8.text := FMovimento.FloatStr(FloatToStr(DataModule1.TMovimento.FieldByName('MovValorDebito').asFloat));
          tirasaldo;
          if pag.Caption = 'DEV' then
          begin
            g.Height := 200;
            lsaldo.visible := true;
            saldo.Visible := true;
            a1.Visible := true;
            a2.Visible := true;
            a3.Visible := true;
            a4.Visible := true;
            a5.Visible := true;
            a6.Visible := true;
            a7.Visible := true;
            a8.Visible := true;
            l1.visible := true;
            valores.visible := true;
            multa.visible := true;
            a1.Text := DataModule1.TMovimento.FieldByName('MovPag').asString;
            multa.Text := FMovimento.FloatStr(FloatToStr(valormulta));
            cobrar.Visible := true;
          end
          else begin
            if DataD.Date > DataModule1.TMovimento.FieldByName('MovDataDevolucao').AsDateTime then
            begin
            g.Height := 200;
            lsaldo.visible := true;
            saldo.Visible := true;
            a1.Visible := true;
            a2.Visible := true;
            a3.Visible := true;
            a4.Visible := true;
            a5.Visible := true;
            a6.Visible := true;
            a7.Visible := true;
            a8.Visible := true;
            l1.visible := true;
            valores.visible := true;
            multa.visible := true;
            cobrar.visible := true;
            a1.Text := DataModule1.TMovimento.FieldByName('MovPag').asString;
            multa.Text := FMovimento.FloatStr(FloatToStr(valormulta));
            end else
            begin
               g.Height := 115;
               lsaldo.visible := false;
               saldo.Visible := false;
               a1.Visible := false;
               a2.Visible := false;
               a3.Visible := false;
               a4.Visible := false;
               a5.Visible := false;
               a6.Visible := false;
               a7.Visible := false;
               a8.Visible := false;
               l1.Visible := false;
               valores.visible := false;
               multa.visible := false;
            end;
          end;

      end;
   end;
end else inicia;
end;
end;



procedure TFDevolucao.FormShow(Sender: TObject);
begin
inicia;
DataD.Date := Date;
f5.Enabled := false;
LSaldo.Font.Color := clBlack;
codigo.setfocus;
end;

procedure TFDevolucao.CodigoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
hora:TDateTime;
begin

if key=vk_f5 then
begin
  if G.Height = 200 then a3.SetFocus
  else begin
     DataModule1.TMovimento.IndexFieldNames := 'Registro';
     DataModule1.TMovimento.FindKey([DataModule1.TFilmes.FieldByName('FilMR').asInteger]);
     DataModule1.TMovimento.Edit;
     DataModule1.TMovimento.FieldByName('DataDR').asDateTime := DataD.Date;
     DataModule1.TMovimento.Post;

     DataModule1.TLancamento.IndexName := 'Movimento';
     DataModule1.TLancamento.Filter:= 'LMovRegistro = ' +
     IntToStr(DataModule1.TFilmes.FieldByName('FilMR').asInteger);
     DataModule1.TLancamento.Filtered := True;
     DataModule1.TLancamento.IndexName := 'LFilme';
     DataModule1.TLancamento.FindKey([StrToInt(codigo.text)]);
     DataModule1.TLancamento.edit;
     DataModule1.TLancamento.FieldByName('LDevolvido').asString := 'Sim';
     DataModule1.TLancamento.FieldByName('LDataDevolucao').value := DataD.Date;
     DataModule1.TLancamento.FieldByName('LHoraDevolucao').value := time;
     DataModule1.TLancamento.Post;
     DataModule1.TLancamento.Filtered := false;

     DataModule1.TFilmes.IndexFieldNames := 'FilCodigo';
     DataModule1.TFilmes.FindKey([StrToInt(codigo.text)]);
     DataModule1.TFilmes.edit;
     DataModule1.TFilmes.FieldByName('FilAlugado').asString := 'No';
     DataModule1.TFilmes.FieldByName('FilMR').Value := null;
     DataModule1.TFilmes.Post;

     ShowMessage('Devoluo com SUCESSO !');
     inicia;
  end;
end;

end;

procedure TFDevolucao.a3KeyPress(Sender: TObject; var Key: Char);
var tot,credito : real;
begin
if (key in ['a'..'z']) and (key in ['A'..'Z']) then key := #0;
if key = #13 then
begin
  if Trim(a3.Text)<>'' then begin
    tot := StrToFloat(a6.Text);
    credito := StrToFloat(a3.Text);
    if (credito > 0) and (credito >=tot)then begin
      a5.Text := FMovimento.FloatStr(FloatToStr(credito-tot));
      a8.Text := '0,00';
    end;
    if (credito >= 0) and (credito <tot) then begin
      a8.Text := FMovimento.FloatStr(FloatToStr((debitoi)+(tot-credito)));
    end;
  end;
end;
end;

procedure TFDevolucao.cobrarClick(Sender: TObject);
begin
if StrtoFloat(multa.text) > 0 then
begin
  a6.text := FMovimento.FloaTStr(FloattoStr(StrToFloat(multa.text) + StrToFloat(a6.text)));
  Saldo.Text := SaldoI;
  tirasaldo;
  a3.setfocus;
end;
end;

procedure TFDevolucao.f5Click(Sender: TObject);
begin
  if pag.Caption = 'DEV' then a3.setfocus
  else begin
     DataModule1.TFilmes.IndexFieldNames := 'FilCodigo';
     DataModule1.TFilmes.FindKey([StrToInt(codigo.text)]);
     DataModule1.TFilmes.edit;
     DataModule1.TFilmes.FieldByName('FilAlugado').asString := 'No';
     DataModule1.TFilmes.Post;
     ShowMessage('Devoluo com SUCESSO !');
     inicia;
  end;
end;

procedure TFDevolucao.Button2Click(Sender: TObject);
begin
encerra;
end;

procedure TFDevolucao.ValoresClick(Sender: TObject);
begin
Saldo.Text := FMovimento.FloatStr(FloatToStr(DataModule1.TClientes.FieldByName('CliSaldo').asFloat));
Saldoi := Saldo.Text;
a6.Text := FMovimento.FloatStr(FloatToStr(TotalI));
a8.Text := FMovimento.FloatStr(FloatToStr(DebitoI));
tirasaldo;
a5.text := '0,00';
end;

procedure TFDevolucao.DataDChange(Sender: TObject);
begin
if multa.Visible then multa.text := FMovimento.FloatStr(FloatToStr(valormulta));
end;

end.
